<?php

/**
 * Класс Pactioner наследник стандарного Actioner
 * Предназначен для выполнения действий,  AJAX запросов плагина 
 *
 * Author: KiisChivarino <kiischivarino@ya.ru>
 */
class Pactioner extends Actioner {
    private  $types = array(
        'sell' => 'Приход',
        'sell_refund' => 'Возврат прихода',
        'sell_correction' => 'Коррекция прихода',
        'buy' => 'Расход',
        'buy_refund' => 'Возврат расхода',
        'buy_correction' => 'Коррекция расхода',
    );
    private $pluginName = 'online-schetmash';

    /**
     * Удаление сущности
     * @return boolean
     */
    public function deleteEntity() {
        $this->messageSucces = $this->lang['ENTITY_DEL'];
        $this->messageError = $this->lang['ENTITY_DEL_NOT'];
        if (DB::query('DELETE FROM `'.PREFIX.$this->pluginName.'` WHERE `id`= '.$_POST['id'])) {
            return true;
        }
        return false;
    }

    /**
     * Контроллер добавления чека
     * @return bool
     * @throws Exception
     */
    public function addCheck(){
        if(isset($_POST['order_id']) && is_numeric($_POST['order_id']) &&  isset($_POST["type"]) && isset($this->types[$_POST["type"]]) ){
            $result = OnlineSchetmash::addCheck($_POST['order_id'], $_POST['type'], $_POST['update']);
            $this->messageError = $result['mess'];
            $this->messageSucces = $result['mess'];
            $this->data = $result['data'];
            return $result['status'];
        }
        return true;
    }

    /**
     * Контроллер обновления чека
     * @return bool
     */
    public function updateCheck(){
        if(isset($_POST['uuid']) ){
            $result = OnlineSchetmash::getStatusCheck((int)$_POST['uuid']);
            $this->messageSucces = $result['mess'];
            $this->messageError = $result['mess'];
            return $result['status'];
        }
        return false;
    }

    /**
     * Сохраняет  опции плагина
     * @return boolean
     */
    public function saveBaseOption() {
        $this->messageSucces = $this->lang['SAVE_BASE'];
        $this->messageError = $this->lang['NOT_SAVE_BASE'];
        if (!empty($_POST['data'])) {
            MG::setOption(array('option' => 'online-schetmashOption', 'value' => addslashes(serialize($_POST['data']))));
        }
        return true;
    }
}